/*
 * Copyright (c) 2009-2014, Christoph Blume
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright notice, 
 * this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice, 
 * this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution.
 * 3. Neither the name of the "Theoretical Computer Science, University of
 * Duisburg-Essen, Germany" nor the names of its contributors may be used to 
 * endorse or promote products derived from this software without specific 
 * prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 */
// Generated from DOT.g4 by ANTLR 4.1

package de.uni_due.inf.ti.raven.antlr;

import org.antlr.v4.runtime.misc.NotNull;
import org.antlr.v4.runtime.tree.ParseTreeListener;

/**
 * This interface defines a complete listener for a parse tree produced by
 * {@link DOTParser}.
 */
@SuppressWarnings("javadoc")
public interface DOTListener extends ParseTreeListener {
	/**
	 * Enter a parse tree produced by {@link DOTParser#port}.
	 * @param ctx the parse tree
	 */
	void enterPort(@NotNull DOTParser.PortContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#port}.
	 * @param ctx the parse tree
	 */
	void exitPort(@NotNull DOTParser.PortContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#attr_stmt}.
	 * @param ctx the parse tree
	 */
	void enterAttr_stmt(@NotNull DOTParser.Attr_stmtContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#attr_stmt}.
	 * @param ctx the parse tree
	 */
	void exitAttr_stmt(@NotNull DOTParser.Attr_stmtContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#edgeop}.
	 * @param ctx the parse tree
	 */
	void enterEdgeop(@NotNull DOTParser.EdgeopContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#edgeop}.
	 * @param ctx the parse tree
	 */
	void exitEdgeop(@NotNull DOTParser.EdgeopContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#stmt_list}.
	 * @param ctx the parse tree
	 */
	void enterStmt_list(@NotNull DOTParser.Stmt_listContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#stmt_list}.
	 * @param ctx the parse tree
	 */
	void exitStmt_list(@NotNull DOTParser.Stmt_listContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#edgeRHS}.
	 * @param ctx the parse tree
	 */
	void enterEdgeRHS(@NotNull DOTParser.EdgeRHSContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#edgeRHS}.
	 * @param ctx the parse tree
	 */
	void exitEdgeRHS(@NotNull DOTParser.EdgeRHSContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#node_id}.
	 * @param ctx the parse tree
	 */
	void enterNode_id(@NotNull DOTParser.Node_idContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#node_id}.
	 * @param ctx the parse tree
	 */
	void exitNode_id(@NotNull DOTParser.Node_idContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#id}.
	 * @param ctx the parse tree
	 */
	void enterId(@NotNull DOTParser.IdContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#id}.
	 * @param ctx the parse tree
	 */
	void exitId(@NotNull DOTParser.IdContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#subgraph}.
	 * @param ctx the parse tree
	 */
	void enterSubgraph(@NotNull DOTParser.SubgraphContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#subgraph}.
	 * @param ctx the parse tree
	 */
	void exitSubgraph(@NotNull DOTParser.SubgraphContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#assignment}.
	 * @param ctx the parse tree
	 */
	void enterAssignment(@NotNull DOTParser.AssignmentContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#assignment}.
	 * @param ctx the parse tree
	 */
	void exitAssignment(@NotNull DOTParser.AssignmentContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#graph}.
	 * @param ctx the parse tree
	 */
	void enterGraph(@NotNull DOTParser.GraphContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#graph}.
	 * @param ctx the parse tree
	 */
	void exitGraph(@NotNull DOTParser.GraphContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#a_list}.
	 * @param ctx the parse tree
	 */
	void enterA_list(@NotNull DOTParser.A_listContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#a_list}.
	 * @param ctx the parse tree
	 */
	void exitA_list(@NotNull DOTParser.A_listContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#attr_list}.
	 * @param ctx the parse tree
	 */
	void enterAttr_list(@NotNull DOTParser.Attr_listContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#attr_list}.
	 * @param ctx the parse tree
	 */
	void exitAttr_list(@NotNull DOTParser.Attr_listContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#nodeStatement}.
	 * @param ctx the parse tree
	 */
	void enterNodeStatement(@NotNull DOTParser.NodeStatementContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#nodeStatement}.
	 * @param ctx the parse tree
	 */
	void exitNodeStatement(@NotNull DOTParser.NodeStatementContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#edge_stmt}.
	 * @param ctx the parse tree
	 */
	void enterEdge_stmt(@NotNull DOTParser.Edge_stmtContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#edge_stmt}.
	 * @param ctx the parse tree
	 */
	void exitEdge_stmt(@NotNull DOTParser.Edge_stmtContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#node_stmt}.
	 * @param ctx the parse tree
	 */
	void enterNode_stmt(@NotNull DOTParser.Node_stmtContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#node_stmt}.
	 * @param ctx the parse tree
	 */
	void exitNode_stmt(@NotNull DOTParser.Node_stmtContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#edgeStatement}.
	 * @param ctx the parse tree
	 */
	void enterEdgeStatement(@NotNull DOTParser.EdgeStatementContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#edgeStatement}.
	 * @param ctx the parse tree
	 */
	void exitEdgeStatement(@NotNull DOTParser.EdgeStatementContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#attributStatement}.
	 * @param ctx the parse tree
	 */
	void enterAttributStatement(@NotNull DOTParser.AttributStatementContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#attributStatement}.
	 * @param ctx the parse tree
	 */
	void exitAttributStatement(@NotNull DOTParser.AttributStatementContext ctx);

	/**
	 * Enter a parse tree produced by {@link DOTParser#subgraphStatement}.
	 * @param ctx the parse tree
	 */
	void enterSubgraphStatement(@NotNull DOTParser.SubgraphStatementContext ctx);
	/**
	 * Exit a parse tree produced by {@link DOTParser#subgraphStatement}.
	 * @param ctx the parse tree
	 */
	void exitSubgraphStatement(@NotNull DOTParser.SubgraphStatementContext ctx);
}