/*
 * Copyright (c) 2009-2014, Christoph Blume
 * All rights reserved.
 * 
 * Redistribution and use in source and binary forms, with or without 
 * modification, are permitted provided that the following conditions are met:
 * 1. Redistributions of source code must retain the above copyright notice, 
 * this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright notice, 
 * this list of conditions and the following disclaimer in the documentation 
 * and/or other materials provided with the distribution.
 * 3. Neither the name of the "Theoretical Computer Science, University of
 * Duisburg-Essen, Germany" nor the names of its contributors may be used to 
 * endorse or promote products derived from this software without specific 
 * prior written permission.
 * 
 * THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS" 
 * AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE 
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE 
 * ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE 
 * LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR 
 * CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF 
 * SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS 
 * INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN 
 * CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) 
 * ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE 
 * POSSIBILITY OF SUCH DAMAGE.
 */

package de.uni_due.inf.ti.raven.messages;

/**
 * This class provides exception messages which should only be displayed to developers.
 * @author Christoph Blume
 * @version $Revision: 1.32 $
 *
 */
public final class RavenExceptionMessages {
	
	/** */
	public static final String ADDING_NODE_NOT_POSSIBLE_EXCEPTION = "The interface must not contain the maximum number of nodes to add a new node.";
	
	/** */
	public static final String ALPHABETS_MUST_BE_EQUAL_EXCEPTION = "The alphabets of the automata must be equal.";
	
	/** */
	public static final String AUTOMATA_MUST_NOT_BE_EQUAL_EXCEPTION = "The automata must not be equal.";
	
	/** */
	public static final String AUTOMATON_MUST_NOT_BE_NULL_EXCEPTION = "The automaton must not be null.";

	/** */
	public static final String AUTOMATON_TYPE_MUST_NOT_BE_NULL_EXCEPTION = "The automaton type must not be null.";
	
	/** */
	public static final String BDD_DOMAIN_MUST_NOT_BE_NULL_EXCEPTION = "The BDD Domain must not be null.";
	
	/** */
	public static final String BDD_MUST_NEITHER_BE_ZERO_NOR_ONE_EXCEPTION = "The state must not be the Zero-BDD or One-BDD.";
	
	/** */
	public static final String BDD_MUST_NOT_BE_NULL_EXCEPTION = "The BDD must not be null.";
	
	/** */
	public static final String BOUND_MUST_NOT_BE_NEGATIVE_EXCEPTION = "The bound must not be negative.";

	/** */
	public static final String CANCEL_NON_RUNNING_ACTION_EXCEPTION = "The action can not be cancelled, since it does not run.";
	
	/** */
	public static final String COSPAN_MUST_NOT_BE_NULL_EXCEPTION = "The cospan must not be null.";
	
	/** */
	public static final String COSPAN_NAME_MUST_NOT_BE_NULL_EXCEPTION = "The cospan name must not be null.";
	
	/** */
	public static final String COSPAN_NOT_FOUND_EXCEPTION = "Cospan not found.";
	
	/** */
	public static final String DATA_MUST_NOT_BE_NULL_EXCEPTION = "The data must not be null.";

	/** */
	public static final String DECOMPOSITION_INCOMPATIBLE_EXCEPTION = "Decomposition is incompatible to automaton.";
	
	/** */
	public static final String DECOMPOSITION_INCOMPATIBLE_TO_ALPHABET_EXCEPTION = "The operations of the decomposition must be contained in the alphabet.";
	
	/** */
	public static final String DECOMPOSITION_MUST_NOT_BE_NULL_EXCEPTION = "The decomposition must not be null.";
	
	/** Density must not be less than 0 Exception */
	public static final String DENSITY_MUST_NOT_BE_LESS_THAN_ZERO_EXCEPTION = "The density must not be less than 0.";
	
	/** Density must not be greater than 1 Exception */
	public static final String DENSITY_MUST_NOT_BE_GREATER_THAN_ONE_EXCEPTION = "The density must not be greater than 1.";
	
	/** */
	public static final String DIFFERENT_ALPHABETS_EXCEPTION = "Alphabets do not match!";

	/** */
	public static final String DIFFERENT_MAXIMUM_INTERFACES_EXCEPTION = "Maximum interface sizes are different.";
	
	/** */
	public static final String DIVISOR_MUST_BE_POSITIVE_EXCEPTION = "The divisor must be positive.";

	/** */
	public static final String DOT_FILE_NOT_FOUND_EXCEPTION = "DOT-File not found.";
	
	/** */
	public static final String DUPLICATE_NAME_EXCEPTION = "The name is already existing.";

	/** */
	public static final String EDGE_MUST_NOT_BE_NULL_EXCEPTION = "The edge must not be null.";
	
	/** */
	public static final String EDGE_NOT_EXISTING_EXCEPTION = "Edge not existing.";
	
	/** */
	public static final String EDGE_ORDER_MUST_NOT_BE_NULL_EXCEPTION = "The edge order must not be null.";
	
	/** */
	public static final String EDGE_SET_MUST_NOT_BE_NULL_EXCEPTION = "The edge set must not be null.";

	/** */
	public static final String ENCODING_LENGTH_MUST_NOT_BE_NEGATIVE_EXCEPTION = "The encoding length size must not be negative.";
	
	/** */
	public static final String ENCODING_MUST_NOT_BE_NULL_EXCEPTION = "The encoding must not be null.";

	/** */
	public static final String ENCODING_NAME_MUST_NOT_BE_NULL_EXCEPTION = "The encoding name must not be null.";
	
	/** */
	public static final String ENCODING_NAME_MUST_NOT_BE_EMPTY_EXCEPTION = "The encoding name must not be empty.";
	
	/** */
	public static final String FILE_NOT_FOUND_EXCEPTION = "The file can not be found.";
	
	/** */
	public static final String FILENAME_MUST_NOT_BE_EMPTY_EXCEPTION = "The file name must not be empty.";
	
	/** */
	public static final String FILENAME_MUST_NOT_BE_NULL_EXCEPTION = "The file name must not be null.";
	
	/** */
	public static final String FIRST_AUTOMATON_MUST_NOT_BE_NULL_EXCEPTION = "The first automaton must not be null.";
	
	/** */
	public static final String FIRST_ENCODING_MUST_NOT_BE_NULL_EXCEPTION = "The first BDD encodings must not be null.";
	
	/** */
	public static final String GRAPH_MUST_NOT_BE_NULL_EXCEPTION = "The graph must not be null.";
	
	/** */
	public static final String GRAPH_NAME_MUST_NOT_BE_NULL_EXCEPTION = "The graph name must not be null.";
	
	/** */
	public static final String GRAPH_NOT_FOUND_EXCEPTION = "Graph not found.";

	/** */
	public static final String GXL_TAG_MUST_NOT_BE_NULL_EXCEPTION = "GXL Tag must not be null.";
	
	/** ID Must Not Be Null Exception Message */
	public static final String ID_MUST_NOT_BE_NULL_EXCEPTION = "The ID must not be null.";
	
	/** ID Must Not Be Empty Exception Message */
	public static final String ID_MUST_NOT_BE_EMPTY_EXCEPTION = "The ID must not be empty.";
	
	/** */
	public static final String ILLEGAL_ARITY_EXCEPTION = "The arity must be in the range of 0 and the current interface size (both inclusive).";
	
	/** Illegal Automaton Exception Message */
	public static final String ILLEGAL_AUTOMATON_EXCEPTION = "Illegal automaton.";
	
	/** */
	public static final String ILLEGAL_BIT_POSITION_EXCEPTION = "Illegal bit position for encoding";
	
	/** */
	public static final String ILLEGAL_COLOR_EXCEPTION = "Illegal color.";

	/** */
	public static final String ILLEGAL_COUNTER_EXCEPTION = "The counter must be in the range of 0 and the bound (both inclusive).";
	
	/** */
	public static final String ILLEGAL_DOMINATING_SET_SIZE_EXCEPTION = "Illegal dominating set size.";

	/** */
	public static final String ILLEGAL_EDGE_LABEL_EXCEPTION = "This edge label is not permitted.";
	
	/** */
	public static final String ILLEGAL_EDGE_LABEL_ARITY_EXCEPTION = "The edge label has the wrong arity.";
	
	/** */
	public static final String ILLEGAL_EDGE_NUMBER_EXCEPTION = "The edge number must be in the range of 0 (inclusive) and the number of edges (exclusive).";
	
	/** */
	public static final String ILLEGAL_EDGE_ORDER_EXCEPTION = "The edge order must exactly contain the edges of the graph.";
	
	/** */
	public static final String ILLEGAL_EVENT_TYPE_EXCEPTION = "The event type is illegal.";
	
	/** */
	public static final String ILLEGAL_GXL_TAG_EXCEPTION = "The GXL Tag is not allowed here.";
	
	/** */
	public static final String ILLEGAL_INTERFACE_NODE_EXCEPTION = "Illegal interface node.";
	
	/** */
	public static final String ILLEGAL_INTERFACE_SIZE_EXCEPTION = "The interface size must be in the range of 0 and the maximum interface size (both inclusive).";
	
	/** */
	public static final String ILLEGAL_LETTER_EXCEPTION = "The letter is illegal, i.e. it is not contained in the signature.";

	/** */
	public static final String ILLEGAL_NAME_EXCEPTION = "Illegal name.";

	/** */
	public static final String ILLEGAL_NODE_ORDER_EXCEPTION = "The node order must exactly contain the nodes of the graph.";
	
	/** */
	public static final String ILLEGAL_OPERATION_STRING_EXCEPTION = "Unparsable operation string.";
	
	/** */
	public static final String ILLEGAL_RANGE_EXCEPTION = "Invalid range for column span";
	
	/** */
	public static final String ILLEGAL_REMAINDER_EXCEPTION = "The remainder must be in the range of 0 (inclusive) and the divisor (exclusive).";
	
	/** Illegal Search Type Exception Message */
	public static final String ILLEGAL_SEARCH_TYPE_EXCEPTION = "Illegal search type for this algorithm.";
	
	/** */
	public static final String ILLEGAL_VERTEX_COVER_SIZE_EXCEPTION = "The size of the vertex cover must be in the range of 0 and the maximum size (both inclusive).";

	/** */
	public static final String INAPPLICABLE_OPERATION_EXCEPTION = "The Operation is incompatible to automaton.";
	
	/** */
	public static final String INCIDENT_NODES_MUST_NOT_BE_NULL_EXCEPTION = "Incident nodes must not be null.";

	/** */
	public static final String INCIDENT_NODES_MUST_BE_CONTAINED_EXCEPTION = "Incident nodes must be contained in this graph.";
	
	/** */
	public static final String INDEX_OUT_OF_BOUNDS_EXCEPTION = "The index is out of bounds.";
	
	/** */
	public static final String INNER_INTERFACE_MUST_BE_CONTAINED_IN_GRAPH_EXCEPTION = "All nodes of the inner interface must be contained in the graph.";
	
	/** Interface Size Must Be Greater Than One Exception */
	public static final String INTERFACE_SIZE_MUST_BE_GREATER_THAN_ONE_EXCEPTION = "The interface must contain at least two nodes.";
	
	/** Interface Size Must Be Greater Than Two Exception */
	public static final String INTERFACE_SIZE_MUST_BE_GREATER_THAN_TWO_EXCEPTION = "The interface must contain at least three nodes.";
	
	/** Interface Size Must Be Greater Than Zero Exception */
	public static final String INTERFACE_SIZE_MUST_BE_GREATER_THAN_ZERO_EXCEPTION = "The interface must contain at least one nodes.";
	
	/** */
	public static final String INNER_INTERFACE_SIZE_MUST_NOT_BE_NEGATIVE_EXCEPTION = "The inner interface size must not be negative.";
	
	/** */
	public static final String INNER_INTERFACE_SIZE_MUST_NOT_BE_GREATER_THAN_THE_MAXIMUM_INTERFACE_EXCEPTION = "The inner interface size must not be greater than the maximum interface.";

	/** */
	public static final String INNER_INTERFACE_SIZES_MUST_NOT_BE_DIFFERENT_EXCEPTION = "The inner interface sizes must not be different.";
	
	/** */
	public static final String INNER_INTERFACE_MUST_NOT_BE_NULL_EXCEPTION = "The inner interface must not be null.";
	
	/** */
	public static final String IO_EXCEPTION_OCCURRED_EXCEPTION = "An I/O error occured. Furhter information can be found in the log file.";
	
	/** */
	public static final String LABEL_MUST_NOT_BE_EMPTY_EXCEPTION = "The label must not be empty.";

	/** */
	public static final String LABEL_MUST_NOT_BE_NULL_EXCEPTION = "The label must not be null.";

	/** */
	public static final String LETTER_MUST_NOT_BE_NULL_EXCEPTION = "The letter must not be null.";
	
	/** */
	public static final String LHS_MUST_NOT_BE_NULL_EXCEPTION = "The left-hand side must not be null.";	

	/** */
	public static final String LOAD_TYPE_MUST_NOT_BE_NULL_EXCEPTION = "The load type must not be null";
	
	/** */
	public static final String MAXIMUM_DOMINATING_SET_SIZE_MUST_BE_POSITIVE_EXCEPTION = "The maximum size of the dominating set must be positive.";
	
	/** */
	public static final String MAXIMUM_INTERFACE_SIZE_MUST_NOT_BE_NEGATIVE_EXCEPTION = "The maximum interface size must not be negative.";
	
	/** */
	public static final String MAXIMUM_INTERFACE_SIZES_MUST_NOT_BE_DIFFERENT_EXCEPTION = "The maximum interface sizes must not be different.";
	
	/** */
	public static final String MAXIMUM_NUMBER_OF_EDGES_MUST_POSITIVE_EXCEPTION = "The maximum number of edges must be positive.";
	
	/** */
	public static final String MAXIMUM_NUMBER_OF_VERTICES_MUST_NOT_BE_NEGATIVE_EXCEPTION = "The maximum number of vertices must not be negative.";
	
	/** */
	public static final String MAXIMUM_VERTEX_COVER_SIZE_MUST_BE_POSITIVE_EXCEPTION = "The maximum size of the vertex cover must not be negative or zero.";
	
	/** */
	public static final String MINIMUM_NUMBER_OF_EDGES_MUST_NOT_BE_NEGATIVE_EXCEPTION = "The minimum number of edges must not be negative.";
	
	/** */
	public static final String MINIMUM_NUMBER_OF_VERTICES_MUST_NOT_BE_NEGATIVE_EXCEPTION = "The minimum numbers of vertices must not be negative.";
	
	/** Name Already In Use Exception */
	public static final String NAME_ALREADY_IN_USE_EXCEPTION = "The name is already in use.";
	
	/** */
	public static final String NAME_MUST_NOT_BE_EMPTY_EXCEPTION = "The name must not be empty.";
	
	/** */
	public static final String NAME_MUST_NOT_BE_NULL_EXCEPTION = "The name must not be null.";

	/** */
	public static final String NAMES_MUST_NOT_BE_EQUAL_EXCEPTION = "The name must not be equal.";
	
	/** */
	public static final String NO_NEIGHBOR_MUST_NOT_BE_NULL_EXCEPTION = "No neighbor must be null.";

	/** */
	public static final String NODE_ALREADY_ADDED_EXCEPTION = "The node has already been added.";
	
	/** */
	public static final String NODE_MUST_NOT_BE_NULL_EXCEPTION = "The node must not be null.";

	/** */
	public static final String NODE_NOT_EXISTING_EXCEPTION = "Node not existing.";

	/** */
	public static final String NODE_ORDER_MUST_NOT_BE_NULL_EXCEPTION = "The node order must not be null.";

	/** */
	public static final String NODE_SET_MUST_NOT_BE_NULL_EXCEPTION = "The node set must not be null.";
	
	/** */
	public static final String NUMBER_MUST_NOT_BE_NEGATIVE_EXCEPTION = "The number must not be negative.";
	
	/** */
	public static final String NUMBER_OF_COLORS_MUST_BE_POSITIVE_EXCEPTION = "The number of colors must be positive.";
	
	/** */
	public static final String NUMBER_OF_NEIGHBORS_MUST_BE_2_OR_LESS_EXCEPTION = "The number of neighbors must be 2 or less.";

	/** */
	public static final String OPERATION_CAN_NOT_BE_ADDED_EXCEPTION = "The operation can not be added to the decomposition.";
	
	/** */
	public static final String OPERATION_LIST_MUST_NOT_BE_NULL_EXCEPTION = "The operation list must not be null.";
	
	/** */
	public static final String ORDERING_TYPE_MUST_NOT_BE_NULL_EXCEPTION = "The ordering type must not be null.";
	
	/** */
	public static final String OUTER_INTERFACE_MUST_BE_CONTAINED_IN_GRAPH_EXCEPTION = "All nodes of the outer interface must be contained in the graph.";
	
	/** */
	public static final String OUTER_INTERFACE_MUST_NOT_BE_NULL_EXCEPTION = "The outer interface must not be null.";
	
	/** */
	public static final String OUTER_INTERFACE_SIZE_MUST_NOT_BE_NEGATIVE_EXCEPTION = "The outer interface size must not be negative.";
	
	/** */
	public static final String OUTER_INTERFACE_SIZE_MUST_NOT_BE_GREATER_THAN_THE_MAXIMUM_INTERFACE_EXCEPTION = "The outer interface size must not be greater than the maximum interface.";
	
	/** */
	public static final String OUTER_INTERFACE_SIZES_MUST_NOT_BE_DIFFERENT_EXCEPTION = "The outer interface sizes must not be different.";
	
	/** */
	public static final String PERMUTATION_MUST_NOT_BE_NULL_EXCEPTION = "The permutation must not be null.";
	
	/** */
	public static final String PERSISTENCE_TYPE_MUST_NOT_BE_NULL_EXCEPTION = "The persistence type must not be null.";
	
	/** */
	public static final String POSITION_MUST_NOT_BE_LESS_OR_EQUAL_TO_INNER_INTERFACE_SIZE_EXCEPTION = "The position must not be less or equal to the inner interface size.";

	/** */
	public static final String POSITION_MUST_NOT_BE_LESS_OR_EQUAL_TO_OUTER_INTERFACE_SIZE_EXCEPTION = "The position must not be less or equal to the outer interface size.";
	
	/** */
	public static final String POSITION_MUST_NOT_BE_NEGATIVE_EXCEPTION = "The position must not be negative.";
	
	/** Preset Node Set Must Not Be Null Exception */
	public static final String PRESET_NODE_SET_MUST_NOT_BE_NULL_EXCEPTION = "The preset node set must not be null.";
	
	/** */
	public static final String PRINTER_MUST_NOT_BE_NULL_EXCEPTION = "The printer must not be null.";

	/** */
	public static final String REPLACEMENT_NAME_MUST_NOT_BE_EMPTY_EXCEPTION = "The replacement name must not be empty.";

	/** */
	public static final String REPLACEMENT_NAME_MUST_NOT_BE_NULL_EXCEPTION = "The replacement name must not be null.";

	/** */
	public static final String RHS_MUST_NOT_BE_NULL_EXCEPTION = "The right-hand side must not be null.";

	/** */
	public static final String SEARCH_TYPE_MUST_NOT_BE_NULL_EXCEPTION = "The search type must not be null.";
	
	/** */
	public static final String SECOND_AUTOMATON_MUST_NOT_BE_NULL_EXCEPTION = "The second automaton must not be null.";
	
	/** */
	public static final String SECOND_ENCODING_MUST_NOT_BE_NULL_EXCEPTION = "The second BDD encodings must not be null.";
	
	/** */
	public static final String SET_OF_LETTERS_MUST_NOT_BE_NULL_EXCEPTION = "The set of letters must not be null.";
	
	/** */
	public static final String SIGNATURE_MUST_NOT_BE_NULL_EXCEPTION = "The signature must not be null.";
	
	/** */
	public static final String SOURCE_NODE_RANGE_EXCEPTION = "The source node must be in the range of 0 (inclusive) and the inner interface size (exclusive).";
	
	/** */
	public static final String SOURCE_NODE_SET_MUST_NOT_BE_NULL_EXCEPTION = "The source nodes must not be null.";
	
	/** */
	public static final String SOURCE_NODE_SIZE_MUST_NOT_BE_GREATER_THAN_INNER_INTERFACE_EXCEPTION = "The number of source nodes must not be greater than the inner interface size.";
	
	/** */
	public static final String TARGET_NODE_RANGE_EXCEPTION = "The target node must be in the range of 0 (inclusive) and the outer interface size (exclusive).";
	
	/** */
	public static final String TARGET_NODE_SET_MUST_NOT_BE_NULL_EXCEPTION = "The target nodes must not be null.";
	
	/** */
	public static final String TARGET_NODE_SIZE_MUST_NOT_BE_GREATER_THAN_OUTER_INTERFACE_EXCEPTION = "The number of target nodes must not be greater than the outer interface size.";

	/** */
	public static final String TEXT_AREA_MUST_NOT_BE_NULL_EXCEPTION = "The text area must not be null.";

	/** */
	public static final String WIDTH_MUST_NOT_BE_NEGATIVE_EXCEPTION = "The width must not be negative.";

	private RavenExceptionMessages() {
		//Do nothing
	}
	
}
